#include <cstdio>
#include <cstdlib>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <QMessageBox>
#include "widget.h"

Widget::Widget(QWidget *parent)
    : QWidget(parent)
{
    QLabel *text_x = new QLabel("Taille x :");
    taille_x = new QSpinBox();
    taille_x->setMinimum(4);
    taille_x->setMaximum(40);
    QLabel *text_y = new QLabel("Taille y :");
    taille_y = new QSpinBox();
    taille_y->setMinimum(4);
    taille_y->setMaximum(40);
    QPushButton *changer_taille = new QPushButton("Valider");


    QHBoxLayout * bouton = new QHBoxLayout();
    bouton->addWidget(text_x);
    bouton->addWidget(taille_x);
    bouton->addWidget(text_y);
    bouton->addWidget(taille_y);
    bouton->addWidget(changer_taille);

    layout = new QGridLayout();
    layout->setSpacing(1);
    QPushButton *terminer = new QPushButton("Generer Le fichier");

    QVBoxLayout * principale = new QVBoxLayout();
    principale->addLayout(bouton);
    principale->addLayout(layout);
    principale->addWidget(terminer);

    this->setLayout(principale);
    connect(changer_taille,SIGNAL(clicked()),this,SLOT(bouton_cliquer()));
    connect(terminer,SIGNAL(clicked()),this,SLOT(generer_carte()));


}

Widget::~Widget()
{

}

void Widget::bouton_cliquer()
{
    if(taille_x->value() % 4 != 0 || taille_y->value() % 4 != 0)
    {
        QMessageBox msgBox;
        msgBox.setText("La taille doit etre un multiple de 4 !");
        msgBox.exec();
        return;
    }
    this->x = taille_x->value();
    this->y = taille_y->value();
    mes_case = new Case[x*y];

    int glo = 0;
    for(int i = 0; i < x ; i++)
    {
        for(int u = 0; u < y ; u++)
        {
           layout->addWidget(&mes_case[glo],i,u);
           glo++;
        }
    }
}

void Widget::generer_carte()
{

      int file = open("grille.bin", O_WRONLY | O_TRUNC | O_CREAT, S_IRUSR | S_IWUSR);
      if(file == -1)
      {
          fprintf(stderr, "L’erreur suivante a été rencontrée lors de l’ouverture .\n");
          exit(EXIT_FAILURE);
      }



      char *terrain= new char[x*y];
      int i,u,glo = 0;
      int nb_max_fantome = 0;
      for(i = 0; i < x; i++)
      {
        for(u = 0; u < y ; u++)
        {
            if(mes_case[glo].text() == "X")
            {
                terrain[glo] = 'X';
            }
            else
            {
                terrain[glo] = ' ';
                nb_max_fantome++;
            }
            glo++;
        }

      }
      nb_max_fantome /= 2;
      if(write(file, &x, sizeof(int)) == -1)
      {


      }

      if(write(file, &y, sizeof(int)) == -1)
      {


      }
      if(write(file, &nb_max_fantome, sizeof(int)) == -1)
      {


      }

      if(write(file, terrain, x * y * sizeof(char)) == -1)
      {


      }
      delete terrain;
      this->close();
}
